; Multiplikation von 2 32-Bit Zahlen (DWORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17:18:19 erster Faktor
;            R20:R21:22:23 zweiter Faktor
; Temporaere Register: R24,R25,R26,R27,R28
;                      R20,R21,R22,R23,R24
ASM_UP_MUL32:

        PUSH       R0
        PUSH       R1

        CLR        R28
        MUL        R21, R17
        MOVW       R27:R26, R1:R0
        MUL        R20, R16
        MOVW       R25:R24, R1:R0
        MUL        R21, R16
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MUL        R17, R20
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MOVW       R17:R16, R25:R24       ; Produkt Low
        MOVW       R19:R18, R27:R26       ; Produkt High

        POP        R1
        POP        R0		

        RET






