; Vergleich von 2 64-Bit Zahlen (Currency)
; Version 1.0, Stand 23.03.2015
;
; Uebergabe: R16:R17:18:19:R20:R21:22:23 erster Faktor
;            R24:R25:26:27:R28:R29:30:31 zweiter Faktor
; Temporaere Register: R0..R9 

; -----------------------------------------
;
; Funktion: - Vergleich von zwei Currency-Zahlen
;           - Vorzeichen werden beachtet (auch mgliche Subtraktion) 
;           - alle temporaeren Register werden gesichert
;
; V1 = V2 
ASM_UP_VER_C_CURR:

; Retten der genutzten temporaeren Register

        PUSH       R0
        PUSH       R1

        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9

        RCALL      ASM_UP_VER_V1V2

        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2


        POP        R1
        POP        R0


        RET







